#ifndef _MATRICE_HPP_
#define  _MATRICE_HPP_


template <int n>
class matrice
{
private:
  double *coeff;
public:
  // Le constructeur par defaut
  matrice(void);
  
  // Le constructeur par copie (a ecrire : la classe matrice<n> contient un pointeur)
  matrice(matrice const&);
  // L'operateur = (meme raison)
  matrice& operator=(matrice const&);
  // Le destructeur (meme raison)
  ~matrice(void)
  {delete [] coeff;}
  

  // L'operateur () pour accéder aux coefficients de la matrice
  double operator()(int i, int j) const;
  double& operator()(int i, int j);

  // Le produit matriciel
  matrice operator* (matrice const& A) const;
  matrice& operator*= (matrice const &A);
};




template <int n>
double matrice<n>::operator() (int i, int j) const
{
  return coeff[i+n*j];
}

template <int n>
double& matrice<n>::operator() (int i, int j)
{
  return coeff[i+n*j];
}



//Le constructeur, par defaut, qui cree la matrice identite.
template <int n>
matrice<n>::matrice(void)
{
  coeff = new double[n*n];
  for (int i=0; i<n; i++)
	for (int j=0; j<n; j++)
	  {
		if (i==j)
		  operator()(i,j) = 1;
		else
		  operator()(i,j) = 0;
	  }
}


// Le constructeur par copie
template <int n>
matrice<n>::matrice(matrice<n> const& A)
{
  coeff = new double[n*n];
  for (int i=0; i<n; i++)
	for (int j=0; j<n; j++)
	  (*this)(i,j) = A(i,j);
}


// L'operateur =
template <int n>
matrice<n>& matrice<n>::operator=(matrice<n> const& A)
{
  for (int i=0; i<n; i++)
	for (int j=0; j<n; j++)
	  (*this)(i,j) = A(i,j);
  return *this;
}


template <int n>
matrice<n>& matrice<n>::operator*= (matrice<n> const &A)
{
  *this = *this * A;
  return *this;
}

// Le produit matriciel
template <int n>
matrice<n> matrice<n>::operator* (matrice<n> const &A) const
{
  matrice<n> prod;
  for (int i=0; i<n; i++)
	for (int j=0; j<n; j++)
	  {
		prod(i,j) = 0;
		for (int k=0; k<n; k++)
		  prod(i,j) += (*this)(i,k) * A(k,j);
	  }
  return prod;
}


#endif /* _MATRICE_HPP_ */
